From 02b2bf7c2f1f00fafde0c08da0dd2ad61f78025b Mon Sep 17 00:00:00 2001
From: Hemanth Sandrana <hemanthforpostgres@gmail.com>
Date: Thu, 19 Oct 2023 17:45:10 +0000
Subject: [PATCH v1] prevent non-superuser terminating superuser owned bgworker
 process.

---
 src/backend/utils/init/miscinit.c | 3 +++
 1 file changed, 3 insertions(+)

diff --git a/src/backend/utils/init/miscinit.c b/src/backend/utils/init/miscinit.c
index 182d666852..d529439919 100644
--- a/src/backend/utils/init/miscinit.c
+++ b/src/backend/utils/init/miscinit.c
@@ -842,6 +842,9 @@ InitializeSessionUserIdStandalone(void)
 
 	AuthenticatedUserId = BOOTSTRAP_SUPERUSERID;
 	SetSessionUserId(BOOTSTRAP_SUPERUSERID, true);
+
+	/* Also mark our PGPROC entry with the  bootstrap superuser id */
+	MyProc->roleId = BOOTSTRAP_SUPERUSERID;
 }
 
 /*
-- 
2.25.1

